package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.RksDaftarIsi;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface RksDaftarIsiRepository extends JpaRepository<RksDaftarIsi, Long> {

    Page<RksDaftarIsi> findByRksDaftarIdAndIsDeleteFalse(Long rksDaftarIsiId, Pageable pageable);

    Optional<RksDaftarIsi> findByIdAndIsDeleteFalse(Long id);

    @Query(value = "SELECT rdi " +
            "FROM RksDaftarIsi rdi " +
            "WHERE rdi.isDelete = false " +
            "AND rdi.parentId = 0")
    List<RksDaftarIsi> findByParentRksDaftarIsi(Long rksDaftarIsiId);

    @Modifying
    @Query(value = "UPDATE rks_daftar_isi " +
            "SET is_delete = 1 " +
            "WHERE rks_daftar_id = :rksDaftarId", nativeQuery = true)
    void deleteRksIsi(@Param("rksDaftarId") Long rksDaftarId);
}
