package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksDaftarRequest;
import com.iconplus.smartproc.repository.RksDaftarRepository;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;

@Service
public class DeleteRksDaftarIsiService implements BaseService<RksDaftarRequest, EmptyResponse> {

    private final RksDaftarRepository rksDaftarRepository;
    private final RksDaftarIsiRepository rksDaftarIsiRepository;
    public DeleteRksDaftarIsiService(RksDaftarRepository rksDaftarRepository,
                                     RksDaftarIsiRepository rksDaftarIsiRepository) {
        this.rksDaftarRepository = rksDaftarRepository;
        this.rksDaftarIsiRepository = rksDaftarIsiRepository;
    }

    @Transactional
    @Override
    public EmptyResponse execute(RksDaftarRequest input) {

        var rksDaftarIsi= rksDaftarRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Daftar Isi", input.getId())));

        rksDaftarIsi.setIsDelete(true);
        rksDaftarRepository.save(rksDaftarIsi);
        rksDaftarIsiRepository.deleteRksIsi(rksDaftarIsi.getId());

        return new EmptyResponse();
    }
}
