package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksDaftarRequest;
import com.iconplus.smartproc.model.response.RksDaftarResponse;
import com.iconplus.smartproc.repository.RksDaftarRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

@Service
public class PutUpdateRksDaftarIsiService implements BaseService<RksDaftarRequest, RksDaftarResponse> {

    private final RksDaftarRepository rksDaftarRepository;
    public PutUpdateRksDaftarIsiService(RksDaftarRepository rksDaftarRepository) {
        this.rksDaftarRepository = rksDaftarRepository;
    }

    @Override
    public RksDaftarResponse execute(RksDaftarRequest input) {

        var rksDaftarIsi= rksDaftarRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Daftar Isi", input.getId())));

        rksDaftarIsi.setKodeTemplate(input.getKodeTemplate());
        rksDaftarIsi.setNamaTemplate(input.getNamaTemplate());
        rksDaftarIsi.setMetodePengadaanId(input.getMetodePengadaanId());
        rksDaftarIsi.setVersi(input.getVersi());

        rksDaftarRepository.save(rksDaftarIsi);

        return RksDaftarResponse.builder()
                .id(rksDaftarIsi.getId())
                .build();
    }
}
