package com.iconplus.smartproc.service.rkstemplate;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksTemplateVariabelRequest;
import com.iconplus.smartproc.model.response.RksTemplateVariabelResponse;
import com.iconplus.smartproc.repository.RksTemplateVariabelRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

@Service
public class PutEditRksTemplateVariabelService implements BaseService<RksTemplateVariabelRequest, RksTemplateVariabelResponse> {

    private final RksTemplateVariabelRepository rksTemplateVariabelRepository;
    public PutEditRksTemplateVariabelService(RksTemplateVariabelRepository rksTemplateVariabelRepository) {
        this.rksTemplateVariabelRepository = rksTemplateVariabelRepository;
    }

    @Override
    public RksTemplateVariabelResponse execute(RksTemplateVariabelRequest input) {

        var rksTemplateVariabel = rksTemplateVariabelRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Template Variabel", input.getId())
                ));

        rksTemplateVariabel.setVariableName(input.getVariableName());
        rksTemplateVariabel.setKeterangan(input.getKeterangan());
        rksTemplateVariabel.setContohIsian(input.getContohIsian());
        rksTemplateVariabel.setDigunakanDi(input.getDigunakanDi());
        rksTemplateVariabel.setIsian(input.getIsian());
        rksTemplateVariabelRepository.save(rksTemplateVariabel);
        return RksTemplateVariabelResponse.builder()
                .id(rksTemplateVariabel.getId())
                .build();
    }
}
